
program TestFijo;
{ Compara la velocidad y precisin de reales vs punto fijo }

{ En un Pentium, la velocidad debe ser casi la misma, debido al
  coprocesador, sin embargo, los nmeros reales son difciles
  de trabajar en ensamblador, por lo que se prefiere el punto fijo    }

uses FMath, Crt;

const num = 500000; { Nmero de iteraciones }

var i : longint;
    f1, f2, f3 : Fixed;
    r1, r2, r3 : real;

begin
     clrscr;
     writeln;
     writeln(' Haciendo ', num, ' divisiones con reales.');
     writeln(' Presiona una tecla para continuar...');
     readkey;

     r1 := 3.14159265;
     r2 := -2.5;
     for i := 1 to num do r3 := r1 / r2;
     writeln(' Resultado: ', r3);

     writeln;
     writeln(' Haciendo ', num, ' divisiones con punto fijo.');
     writeln(' Presiona una tecla para continuar...');
     readkey;

     f1 := Real2Fixed(3.14159265);
     f2 := Real2Fixed(-2.5);
     for i := 1 to num do f3 := FDiv(f1, f2);
     writeln(' Resultado: ', Fixed2Real(f3));

     writeln;
     writeln(' Presiona una tecla para terminar...');
     readkey;
end.
